/* **************************************************************************** */
/*                                                                              */
/*  Copyright (c) 2011 University of Southern California (USC)  		*/
/*                                                                              */
/*  All rights reserved.                                                        */
/*                                                                              */
/*  Permission is given to use, copy, and modify this software for any          */
/*  non-commercial purpose as long as this copyright notice is not removed      */
/*  All other uses, including redistribution in whole or in part, are           */
/*  forbidden without prior written permission.                                 */
/*                                                                              */
/*  This software is provided with absolutely no warranty and no support.       */
/*                                                                              */
/*  For further information contact: pedro@isi.edu				*/
/*                                                                              */
/* **************************************************************************** */

/*----------------------------------------------------------------------------+
| Module: hashtable.h
+----------------------------------------------------------------------------*/

#ifndef HASH_H
#define HASH_H

#include "structs.h"

#define hashtable_default_size 16

typedef struct hb {
  int key;
  symbol_t *sym;
  struct hb* next;
} hashbucket;

typedef struct {
  int size;
  hashbucket **table;
} hashtable;

extern int 		hash(hashtable *ht, char *str);
extern hashtable* 	createHashTable(int size);
extern void 		destroyHashTable(hashtable *ht);
extern symbol_t*	insertItem(hashtable *ht, int idx, symbol_t *sym);
extern symbol_t*	lookupItem(hashtable *ht, int *found, char *c);
extern void		removeItem(hashtable *ht, char *it);

#endif
